searchNodes=[{"doc":"Some common utility functions.","ref":"Bundlex.html","title":"Bundlex","type":"module"},{"doc":"Returns path where compiled native is stored.","ref":"Bundlex.html#build_path/3","title":"Bundlex.build_path/3","type":"function"},{"doc":"Returns family of the platform obtained with platform/0 .","ref":"Bundlex.html#family/0","title":"Bundlex.family/0","type":"function"},{"doc":"Returns current platform name.","ref":"Bundlex.html#platform/0","title":"Bundlex.platform/0","type":"function"},{"doc":"","ref":"Bundlex.html#t:platform_t/0","title":"Bundlex.platform_t/0","type":"type"},{"doc":"Utilities to ease interaction with Bundlex-based CNodes, so they can be treated more like Elixir processes / GenServer s.","ref":"Bundlex.CNode.html","title":"Bundlex.CNode","type":"module"},{"doc":"Makes a synchronous call to CNode and waits for its reply. The CNode is supposed to send back a {cnode, response} tuple where cnode is the node name of CNode. If the response doesn't come in within timeout , error is raised. Messages are exchanged directly (without interacting with CNode's associated server).","ref":"Bundlex.CNode.html#call/3","title":"Bundlex.CNode.call/3","type":"function"},{"doc":"Starts monitoring CNode from the calling process.","ref":"Bundlex.CNode.html#monitor/1","title":"Bundlex.CNode.monitor/1","type":"function"},{"doc":"Sends a message to cnode. The message is exchanged directly (without interacting with CNode's associated server).","ref":"Bundlex.CNode.html#send/2","title":"Bundlex.CNode.send/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module. See Bundlex.CNode.start/2 for more details.","ref":"Bundlex.CNode.html#start/1","title":"Bundlex.CNode.start/1","type":"macro"},{"doc":"Works the same way as start_link/2 , but does not link to CNode's associated server.","ref":"Bundlex.CNode.html#start/2","title":"Bundlex.CNode.start/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module. See Bundlex.CNode.start_link/2 for more details.","ref":"Bundlex.CNode.html#start_link/1","title":"Bundlex.CNode.start_link/1","type":"macro"},{"doc":"Spawns and connects to CNode cnode_name from application app . The CNode is passed the following command line arguments: host name, alive name, node name, creation number. After CNode startup, these parameters should be passed to ei_connect_xinit function, and CNode should be published and await connection. Once the CNode is published, it should print a line starting with ready to the standard output and flush the standard output to avoid the line being buffered. Under the hood, this function starts an associated server, which is responsible for monitoring the CNode and monitoring calling process to be able to do proper cleanup upon a crash. On startup, the server does the following: Makes current node distributed if it is not done yet (see Node.start/3 ). Assigns CNode a unique name. Starts CNode OS process using Port.open/2 . Waits (at most 5 seconds) until a line ready is printed out (this line is captured and not forwarded to the stdout). Connects to the CNode. The erlang cookie is passed using the BUNDLEX_ERLANG_COOKIE an environment variable.","ref":"Bundlex.CNode.html#start_link/2","title":"Bundlex.CNode.start_link/2","type":"function"},{"doc":"Disconnects from CNode. It is the responsibility of the CNode to exit upon connection loss.","ref":"Bundlex.CNode.html#stop/1","title":"Bundlex.CNode.stop/1","type":"function"},{"doc":"","ref":"Bundlex.CNode.html#t:on_start_t/0","title":"Bundlex.CNode.on_start_t/0","type":"type"},{"doc":"Reference to the CNode. Consists of pid of CNode's associated server and CNode name.","ref":"Bundlex.CNode.html#t:t/0","title":"Bundlex.CNode.t/0","type":"type"},{"doc":"Some utilities to ease loading of Bundlex-based NIFs.","ref":"Bundlex.Loader.html","title":"Bundlex.Loader","type":"module"},{"doc":"Binds the module to the specified NIF. Accepts keyword list, that may contain two arguments: :nif - required, name of the NIF to be bound (the same as specified in bundlex.exs ) :app - application defining the NIF, defaults to the current application After use 'ing this module you can utilize defnif/1 and defnifp/1 macros to create bindings to particular native functions. Example defmodule My.Native.Module do use Bundlex.Loader , nif : :my_nif defnif native_function ( arg1 , arg2 , arg3 ) def normal_function ( arg1 , arg2 ) do # ... end defnifp private_native_function ( arg1 , arg2 ) end","ref":"Bundlex.Loader.html#__using__/1","title":"Bundlex.Loader.__using__/1","type":"macro"},{"doc":"Generates function bound to the native implementation. This module has to be use d for this macro to work. Function name should correspond to the native one. See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnif/1","title":"Bundlex.Loader.defnif/1","type":"macro"},{"doc":"Works the same way as defnif/1 , but generates private function. This module has to be use d for this macro to work. See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnifp/1","title":"Bundlex.Loader.defnifp/1","type":"macro"},{"doc":"Binds calling module to NIF nif_name from application app . Second argument has to be an atom, the same as name of the NIF in the bundlex project. Invoked internally by __using__/1 macro, which is the preferred way of loading NIFs.","ref":"Bundlex.Loader.html#load_nif!/2","title":"Bundlex.Loader.load_nif!/2","type":"macro"},{"doc":"Module responsible for parsing and processing natives' configurations.","ref":"Bundlex.Native.html","title":"Bundlex.Native","type":"module"},{"doc":"Parses natives and generates compiler commands.","ref":"Bundlex.Native.html#resolve_natives/2","title":"Bundlex.Native.resolve_natives/2","type":"function"},{"doc":"","ref":"Bundlex.Native.html#t:interface_t/0","title":"Bundlex.Native.interface_t/0","type":"type"},{"doc":"","ref":"Bundlex.Native.html#t:language_t/0","title":"Bundlex.Native.language_t/0","type":"type"},{"doc":"","ref":"Bundlex.Native.html#t:name_t/0","title":"Bundlex.Native.name_t/0","type":"type"},{"doc":"","ref":"Bundlex.Native.html#t:t/0","title":"Bundlex.Native.t/0","type":"type"},{"doc":"Utilities to ease interaction with Ports.","ref":"Bundlex.Port.html","title":"Bundlex.Port","type":"module"},{"doc":"Spawns Port native_name from application of calling module. Returned result is compatible with standard Port API.","ref":"Bundlex.Port.html#open/2","title":"Bundlex.Port.open/2","type":"macro"},{"doc":"","ref":"Bundlex.Port.html#open/3","title":"Bundlex.Port.open/3","type":"function"},{"doc":"Behaviour that should be implemented by each project using Bundlex in the bundlex.exs file.","ref":"Bundlex.Project.html","title":"Bundlex.Project","type":"behaviour"},{"doc":"Returns the project struct of given application. If the module has not been loaded yet, it is loaded from project_dir/bundlex.exs file.","ref":"Bundlex.Project.html#get/1","title":"Bundlex.Project.get/1","type":"function"},{"doc":"","ref":"Bundlex.Project.html#native_config_keys/0","title":"Bundlex.Project.native_config_keys/0","type":"function"},{"doc":"Callback returning project configuration.","ref":"Bundlex.Project.html#c:project/0","title":"Bundlex.Project.project/0","type":"callback"},{"doc":"Determines if module is a bundlex project module.","ref":"Bundlex.Project.html#project_module?/1","title":"Bundlex.Project.project_module?/1","type":"function"},{"doc":"Type describing input project configuration. It's a keyword list, where natives and libs can be specified. Libs are native packages that are compiled as static libraries and linked to natives that have them specified in deps field of their configuration.","ref":"Bundlex.Project.html#t:config_t/0","title":"Bundlex.Project.config_t/0","type":"type"},{"doc":"Type describing configuration of a native. It's a keyword list containing the following keys: sources - C files to be compiled (at least one must be provided), includes - Paths to look for header files (empty list by default). lib_dirs - Paths to look for libraries (empty list by default). libs - Names of libraries to link (empty list by default). pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default). deps - Dependencies in the form of {app, lib_name} , where app is the application name of the dependency, and lib_name is the name of lib specified in bundlex project of this dependency. See Dependencies section in readme for details. src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default). compiler_flags - Custom flags for compiler. linker_flags - Custom flags for linker. language - Language of native. :c or :cpp may be chosen (:c by default) interface - Interface of native. It can be single atom e.g. :nif or list of atoms. preprocessors - Modules implementing Bundlex.Project.Preprocessor behaviour","ref":"Bundlex.Project.html#t:native_config_t/0","title":"Bundlex.Project.native_config_t/0","type":"type"},{"doc":"","ref":"Bundlex.Project.html#t:native_name_t/0","title":"Bundlex.Project.native_name_t/0","type":"type"},{"doc":"Struct representing bundlex project. Contains the following fields: :config - project configuration :src_path - path to the native sources :module - bundlex project module :app - application that exports project","ref":"Bundlex.Project.html#t:t/0","title":"Bundlex.Project.t/0","type":"type"},{"doc":"Behaviour for preprocessing Bundlex projects. Precompiling may involve either generating additional resources or altering the project itself. Currently, preprocessing native configuration ( preprocess_native_config/3 ) and parsed natives ( preprocess_native/1 ) is supported.","ref":"Bundlex.Project.Preprocessor.html","title":"Bundlex.Project.Preprocessor","type":"behaviour"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#c:preprocess_native/1","title":"Bundlex.Project.Preprocessor.preprocess_native/1","type":"callback"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#c:preprocess_native_config/3","title":"Bundlex.Project.Preprocessor.preprocess_native_config/3","type":"callback"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#t:t/0","title":"Bundlex.Project.Preprocessor.t/0","type":"type"},{"doc":"Builds natives specified in bundlex.exs file Accepts the following command line arguments: --store-scripts - if set, shell scripts are stored in the project root folder for further analysis. Add :bundlex to compilers in your Mix project to have this task executed each time the project is compiled.","ref":"Mix.Tasks.Compile.Bundlex.html","title":"Mix.Tasks.Compile.Bundlex","type":"task"},{"doc":"Bundlex is a multi-platform tool for compiling C code along with elixir projects, for use in NIFs, CNodes and Ports. The tool also provides a convenient way of accessing compiled code in elixir modules. Bundlex has been tested on Linux, Mac OS and FreeBSD. There's some support for Windows as well, but it's experimental and unstable (see issues for details). This tool is maintained by the Membrane Framework team.","ref":"readme.html","title":"Bundlex","type":"extras"},{"doc":"To install, you need to configure Mix project as follows: defmodule MyApp.Mixfile do use Mix.Project def project do [ app : :my_app , compilers : [ :bundlex ] ++ Mix . compilers , # add bundlex to compilers deps : deps ( ) , # ... ] end defp deps ( ) do [ { :bundlex , &quot;~&gt; 1.0.1&quot; } ] end end and create bundlex.exs file in the project root folder, containing Bundlex project module: defmodule MyApp.BundlexProject do use Bundlex.Project def project ( ) do [ ] end end Now your project does not contain any C sources, but should compile successfully, and some Bundlex messages should be printed while compilation proceeds.","ref":"readme.html#installation","title":"Bundlex - Installation","type":"extras"},{"doc":"Adding natives to project Adding natives can be done in project/0 function of Bundlex project module in the following way: defmodule MyApp.BundlexProject do use Bundlex.Project def project ( ) do [ natives : natives ( Bundlex . platform ) , libs : libs ( ) ] end defp natives ( :linux ) do [ my_native : [ sources : [ &quot;something.c&quot; , &quot;linux_specific.c&quot; ] , interface : :nif ] , my_other_native : [ sources : [ &quot;something_other.c&quot; , &quot;linux_specific.c&quot; ] , interface : :cnode ] , my_other_native : [ sources : [ &quot;something_more_other.c&quot; , &quot;linux_specific.c&quot; ] , interface : :port ] ] end defp natives ( _platform ) do [ my_native : [ sources : [ &quot;something.c&quot; , &quot;multiplatform.c&quot; ] , interface : :nif ] , my_other_native : [ sources : [ &quot;something_other.c&quot; , &quot;multiplatform.c&quot; ] , interface : :cnode ] , my_other_native : [ sources : [ &quot;something_more_other.c&quot; , &quot;multiplatform.c&quot; ] , interface : :port ] ] end defp libs ( ) do [ my_lib : [ sources : [ &quot;something.c&quot; ] , interface : :nif ] , my_lib : [ sources : [ &quot;something_other.c&quot; ] , interface : :cnode ] ] end end As we can see, we can specify two types of resources: natives - code implemented in C that will be used within Elixir code libs - can be used by other resources as dependencies (see deps option below) The sources should reside in project_root/c_src/my_app directory (this can be changed with src_base option, see below). Configuration of each native may contain following options: sources - C files to be compiled (at least one must be provided), includes - Paths to look for header files (empty list by default). lib_dirs - Absolute paths to look for libraries (empty list by default). libs - Names of libraries to link (empty list by default). pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default). deps - Dependencies in the form of {app, lib_name} , where app is the application name of the dependency, and lib_name is the name of lib specified in Bundlex project of this dependency. Empty list by default. See Dependencies section below for details. src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default). compiler_flags - Custom flags for compiler. Default -std flag for :c is -std=c11 and for :cpp is -std=c++17 . linker_flags - Custom flags for linker. language - Language of native. :c or :cpp may be chosen ( :c by default) interface - Interface used to integrate with Elixir code. The following interfaces are available: :nif - dynamically linked to the Erlang VM (see Erlang docs ) :cnode - executed as separate OS processes, accessed through sockets (see Erlang docs ) :port - executed as separate OS processes (see Elixir Port docs ) Specifying no interface is valid only for libs. preprocessors - Modules that will preprocess the native, see Bundlex.Project.Preprocessor . Dependencies Each native can have dependencies - libs that are statically linked to it and can be included in its native code like #include lib_name/some_header.h . The following rules apply: To add dependencies from a separate project, it must be available via Mix. Only libs can be added as dependencies. Each dependency of a native must specify the same or no interface. If there exist multiple versions of dependency with different interfaces, the proper version is selected automatically. A lib that specifies no interface can depend on libs with no interfaces only. Compilation options The following command-line arguments can be passed: --store-scripts - if set, shell scripts are stored in the project root folder for further analysis. Loading NIFs in modules NIFs compiled with Bundlex can be loaded the same way as any other NIFs (see :erlang.load_nif/2 ), but Bundlex provides Bundlex.Loader module to save you some boilerplate: defmodule MyApp.SomeNativeStuff do use Bundlex.Loader , nif : :my_nif def normal_function ( a , b , c , d ) do private_native_function ( a + b , c + d ) end defnif native_function ( a , b ) defnifp private_native_function ( x , y ) end Note that unlike when using :erlang.load_nif/2 , here def s and defp s can be used to create usual functions, native ones are declared with defnif and defnifp . This is achieved by creating a new module under the hood, and that is why the module passed to C macro ERL_NIF_INIT has to be succeeded by .Nif , i.e. ERL_NIF_INIT(MyApp.SomeNativeStuff.Nif, funs, load, NULL, upgrade, unload) Despite this, any native erlang macros and functions shall be used as usual, as described at http://erlang.org/doc/man/erl_nif.html Interacting with CNodes As in the case of NIFs, CNodes compiled with Bundlex can be used like any other CNodes (see built-in Node module), while some useful stuff for interacting with them is provided. Bundlex.CNode module contains utilities that make it easier to spawn and control CNodes, and allow them to treat them more like usual Elixir processes. Check out the documentation for more details. Interacting with Ports Similarly to CNodes Bundlex provides Bundlex.Port module for a little easier interacting with Ports. Please refer to the module's documentation to see how to use it.","ref":"readme.html#usage","title":"Bundlex - Usage","type":"extras"},{"doc":"More advanced examples can be found in our test_projects or in our repositories where we use Bundlex e.g. in Unifex .","ref":"readme.html#more-examples","title":"Bundlex - More examples","type":"extras"},{"doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Bundlex - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]